
;****************************************************************************************
;*                              SERVO-SCHALTER                                          *
;*                              15.05.16                                                *
;*--------------------------------------------------------------------------------------*
;*                                                                                      *
;* ALS PIC-IC WURDE GENOMMEN PIC12F683                                                  *
;* ALS OSZILLATOR WURDE DER INTERNE RC-OSZILLATOR MIT 8,000MHZ EINGESTELLT              *
;* (T=0.125SEC ALSO DIE TAKTZEIT)                                                      *
;*  EIN BEFEHL HAT MEIST 4 TAKTE SIND 0,5SEC                                           *
;*                                                                                      *
;****************************************************************************************

        LIST    P=12F683       
        TITLE   "SERVO-SCHALTER"

        ERRORLEVEL -302
        INCLUDE <P12F683.INC>


__CONFIG _INTRC_OSC_NOCLKOUT &_INTOSCIO & _IESO_OFF & _FCMEN_OFF &_WDT_OFF & _PWRTE_OFF & _BOD_OFF & _MCLRE_OFF & _CPD_OFF & _CP_OFF


;--------------------------------------------------------------------------
;REGISTER ZUORDNEN NACH DEM DIE FESTEN-REGISTER ZU ENDE SIND
;ES GEHT ALSO ERST AB 22 HEX LOS
;DIES IST ALSO DIE RAM-SPEICHER ZUORDNUNG


MERK                    EQU 0X22
;ZEITVARIABLE IN UNTERPROG. / VERARBEITET DIE DURCHLUFE / WIE OFT DIE ZEITSCHLEIFE ABGEARBEITET WIRD
;WERTE VON 1 DEZ. BIS 255 DEZ.

IMPULS                  EQU 0X23               ;MESSEN RX-IMPULSLNGE

STELL                   EQU 0X24               ;STELLEN/SCHALTEN 

MAL                     EQU 0X25               ;NUR 1 MAL BEI FLIP-FLOP

IMPULS_L                EQU 0X26               ;BERECHNUNG AUTOMATISCHE MITTELSTELLUNG
IMPULS_H                EQU 0X27
ZAE                     EQU 0X28

MIN                     EQU 0X29               ;UNTERHALB VOM STEUERHEBEL SCHALTET ES
MAX                     EQU 0X2A               ;OBERHALB VOM STEUERHEBEL SCHALTET ES

W_STACK                 EQU 0X2B               ;FUER PUSH UND POP ;FUER INTERRUPT
S_STACK                 EQU 0X2C               ;FUER PUSH UND POP

;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;--------------------------------------------------------------------------
;-------------------------- FESTE WERTE HIER EINTRAGEN / NDERN -----------
;-------------------------- ALSO HIER JUSTIEREN ---------------------------
;-------------------------- MAN MUSS PROBIEREN ----------------------------

BERECH                  EQU D'51'               ;UNTERHALB UND OBERHALB 20% VON DER MITTELSTELLUNG DES STEUERKNPPELS SCHALTET ES

;BERECHNUNG:
;DEZIMAL 255 ENTSPRECHEN 100%

;FR +/- 10%
;255*0,1=25 DIES OBEN EINTRAGEN


;FR +/- 20%
;255*0,2=51 DIES OBEN EINTRAGEN


;FR +/- 30%
;255*0,3=76 DIES OBEN EINTRAGEN


;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;------------------------------- ENDE -------------------------------------

;------------------------- MACROS -----------------------------------------

BANK0                   MACRO                   ;MACRO TO SELECT DATA RAM BANK 0
                        BCF     STATUS,RP0
                        ENDM
;----------------------------------------------------------------------------
BANK1                   MACRO                   ;MACRO TO SELECT DATA RAM BANK 1
                        BSF     STATUS,RP0
                        ENDM
;----------------------------------------------------------------------------
PUSH                    MACRO
                        MOVWF   W_STACK
                        MOVF    STATUS, W
                        MOVWF   S_STACK
                        ENDM
;----------------------------------------------------------------------------
POP                     MACRO
                        MOVF    S_STACK, W
                        MOVWF   STATUS
                        SWAPF   W_STACK, F
                        SWAPF   W_STACK, W
                        ENDM
;----------------------------------------------------------------------------


;VARIABLEN
BIT0        EQU 0
BIT1        EQU 1
BIT2        EQU 2
BIT3        EQU 3
BIT4        EQU 4
BIT5        EQU 5
BIT6        EQU 6
BIT7        EQU 7

GP0         EQU 0
GP1         EQU 1 
GP2         EQU 2 
GP3         EQU 3 
GP4         EQU 4
GP5         EQU 5 



;SPEICHERANFANG BZW. BEGINN
    ORG 0X0000
    GOTO MAIN           ; SPRUNG ZUM HAUPTPROGRAMM
    ORG 0X0004
    GOTO INTERRUPT      ; ZUM INTERRUPT

    ORG 0X0010
;*****************************************************************************
;*                            HAUPTPROGRAMM                                  *
;*****************************************************************************
;PORT-INITIALISIERUNG
MAIN                    BANK0
                        CLRF    GPIO     
                        MOVLW   0X07                        ;COMPARATORS ALLE AUS 
                        MOVWF   CMCON0

                        BANK1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 
                        CLRF    ANSEL                       ;ALLE PORTS I/O

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                        MOVLW   B'11101100'                 ;GP0 + GP1 + GP4 ALS AUSGANG (ALSO HIER DIE 0), SONST ALLES EINGNGE (ALSO IMMER DIE (1))
                        MOVWF   TRISIO

;OSCILLATOR AUF 8MHZ INTERN EINSTELLEN
                        MOVLW   B'01110101'
                        MOVWF   OSCCON

;INIT TIMER0
                        MOVLW   B'10000010'   ;BIT0-2 1=PRESCALER 1:8, BIT3 0=TMR0, BIT4 0=ENTFAELLT, 
                                              ;BIT5 0=TAKT VOM SYSTEM, BIT6 0=KEIN RB-INTERRUPT, BIT7 1=PULL-UPS DISABLE 
                        MOVWF   OPTION_REG

;INIT INTERRUPT AN GP5
                        BCF     OPTION_REG, INTEDG  ;FALLENDE FLANKE ZULASSEN
                        BSF     INTCON, GPIE        ;INTERRUPT FR EXTERNEN PIN ZULASSEN MIT CHANGE VON GP2 AUF GP-EINGANG!!!
                        BSF     IOC, IOC5           ;ANDERS ZUSTZLICH ZU GP2 
                        BANK0

;DIE LEDS... SOLLEN AM ANFANG AUS SEIN              
                        BCF     GPIO, GP0                   ;AUS
                        BCF     GPIO, GP1                   ;AUS
                        BCF     GPIO, GP4                   ;AUS

                        CLRF    STELL
                        CLRF    MAL

;INTERRUPT GP5 INIT / ZULASSEN
;FR EMPFNGER-SERVO-IMPULS VON 1,9MSEC-2,1MSEC MESSEN
                        BCF     INTCON, GPIF        ;INTERRUPT-FLAG WIRD ERST BEI INTERRUPT GESETZT / JETZT LSCHEN
                        BCF     INTCON, INTF        ;INTERRUPT-FLAG WIRD ERST BEI INTERRUPT GESETZT / JETZT LSCHEN
;----------------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------------
;------------------------- INITIALISIERUNG PORTS... ZU ENDE -----------------------------------------
;----------------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------------

            MOVLW   D'200'
            CALL    ZS1MSEC             ;200MSEC ZEITSCHLEIFE DAMIT SICH KONDENSATOREN AUFLADEN NACH DEM EINSCHALTEN

;----------
;WENN MAN DEN SENDER ZUERST EINSCHALTET WARTET ES AUF 100 IMPULSE

;WENN DER EMPFNGER ZUERST AN IST, WIRD ERST NACH 100 IMPULSEN GEMESSEN.
;ES MUSS SICH DER SENDER ERST EINSCHWINGEN
            MOVLW   D'100'
            MOVWF   ZAE                 ;100 MAL DURCHLUFE

VOR1        BTFSC   GPIO, GP5           ;WARTEN BIS ES NEGATIV WIRD 
            GOTO    VOR1

VOR         BTFSS   GPIO, GP5           ;IMPULS-LNGE IST LOW
            GOTO    VOR

            DECFSZ  ZAE, F              ;DURCHLUFE ZAEHLEN
            GOTO    VOR1

;----------
;----------
            CLRF    IMPULS_L
            CLRF    IMPULS_H
            MOVLW   D'8'
            MOVWF   ZAE                 ;8 MAL DURCHLUFE

IMPP        BTFSS   GPIO, GP5           ;WARTEN BIS ES POSITIV WIRD / NICHT ZWISCHEN EINEM LAUFENDEN IMPULS SCHON MESSEN
            GOTO    IMPP

IMP         BTFSC   GPIO, GP5           ;IMPULS-LNGE BEGINN JETZT MESSEN BEI LOW
            GOTO    IMP

;EMPFNGER-IMPULS-LNGE MESSEN
;FESTE IMPULS-ZEIT 0,9MSEC ///BERECHNUNG DER 31DEZ. STEHT UNTERHALB BEI ZEITSCHLEIFEN UNTERPROGRAMM !
;AN GP5 MESSEN
            MOVLW   D'31'
            MOVWF   TMR0                    ;DER FESTE RAM-SPEICHER (TMR0) WIRD MIT 31 GELADEN
            BCF     INTCON, T0IF            ;OVERFLOW = 0
                
JRX0        BTFSS   INTCON, T0IF            ;WENN DIE ZEIT VON 1MSEC ABGELAUFEN IST, WIRD T0IF HIGH (1) UND 
            GOTO    JRX0                    ;ES ERFOLGT EIN SPRUNG 


;IMPULSZEIT MESSEN
            MOVLW   D'1'        ;
            MOVWF   IMPULS      ;

JRX1        NOP
            NOP 
            NOP 
            NOP 
            INCFSZ  IMPULS, F   ;T=4
            GOTO    JRX3        ;T=8 GESAMT: T=12

            MOVLW   0XFF        ;BERLAUF BEI GRSSER 2,1MSEC
            MOVWF   IMPULS
JRX2        BTFSS   GPIO, GP5
            GOTO    JRX2
            GOTO    BERECHNUNG

JRX3        BTFSS   GPIO, GP5   ;T=4        ;STEIGENDE FLANKE == ZEITMESSUNG BEENDEN
            GOTO    JRX1        ;T=8 +GESAMT AUCH VON OBEN: 12+12=24T

                                ;BERECHNUNG:
                                ;1,1MSEC : 250 ALS MAX.-WERT FR MERK = 4,4SEC
                                ;4,4SEC : 0,125SEC = 35,2T
                                
                                ;ALSO 35T - 24T = 11T
                                ;11 : X-MAL NOP (MIT T=4) = 2,75MAL NOP
                                ;ALSO 2 ODER 3 MAL NOPS EINTRAGEN BEI RX1  --->PROBIEREN

                                ;ERGEBNIS:
                                ;BEI 4 MAL NOPS GING ES AM BESTEN !!!!!!!!!!!!!!


BERECHNUNG  MOVF    IMPULS, W
            ADDWF   IMPULS_L, F
            BTFSS   STATUS, C
            GOTO    BER1
            INCF    IMPULS_H, F

BER1        DECFSZ  ZAE, F      ;DURCHLUFE
            GOTO    IMP

            BCF     STATUS, C   ;1X RECHTS SCHIEBEN :2 / 8:2=4
            RRF     IMPULS_H, F
            RRF     IMPULS_L, F

            BCF     STATUS, C   ;1X RECHTS SCHIEBEN :2 / 4:2=2
            RRF     IMPULS_H, F
            RRF     IMPULS_L, F
     
            BCF     STATUS, C   ;1X RECHTS SCHIEBEN :2 / 2:2=1
            RRF     IMPULS_H, F
            RRF     IMPULS_L, F
 
            MOVLW   BERECH      ;OK
            ADDWF   IMPULS_L, W
            BTFSC   STATUS, C
            GOTO    FEHLER
            MOVWF   MAX

            MOVLW   BERECH      ;OK
            SUBWF   IMPULS_L, W
            BTFSS   STATUS, C
            GOTO    FEHLER
            MOVWF   MIN
    
;----------


            BSF     GPIO, GP4           ;KONTROLL-LED EIN

            BSF     INTCON, GIE         ;INTERRUPT EINSCHALTEN

;----------------------------------------------------------------------------------------------------
ANF         GOTO    ANF

;----------------------------------------------------------------------------------------------------
FEHLER      BSF     GPIO, GP4           ;WARNUNG AN KONTROLL-LED BLINKT
            MOVLW   D'3'
            MOVWF   ZAE
FEH1        MOVLW   D'100'
            CALL    ZS1MSEC             ;100MSEC ZEITSCHLEIFE 
            DECFSZ  ZAE, F
            GOTO    FEH1

            BCF     GPIO, GP4           ;WARNUNG AN KONTROLL-LED BLINKT
            MOVLW   D'3'
            MOVWF   ZAE
FEH2        MOVLW   D'100'
            CALL    ZS1MSEC             ;100MSEC ZEITSCHLEIFE 
            DECFSZ  ZAE, F
            GOTO    FEH2
            GOTO    FEHLER

;*****************************************************************************
;*                              INTERRUPT-PROGRAMM                           *
;*                              19.09.05                                     *
;*****************************************************************************
INTERRUPT   PUSH

;EMPFNGER-IMPULS-LNGE MESSEN
;FESTE IMPULS-ZEIT 0,9MSEC ///BERECHNUNG DER 31DEZ. STEHT UNTERHALB BEI ZEITSCHLEIFEN UNTERPROGRAMM !
;AN GP5 MESSEN
            MOVLW   D'31'
            MOVWF   TMR0                    ;DER FESTE RAM-SPEICHER (TMR0) WIRD MIT 31 GELADEN
            BCF     INTCON, T0IF            ;OVERFLOW = 0
                
RX0         BTFSS   INTCON, T0IF            ;WENN DIE ZEIT VON 1MSEC ABGELAUFEN IST, WIRD T0IF HIGH (1) UND 
            GOTO    RX0                     ;ES ERFOLGT EIN SPRUNG 


;IMPULSZEIT MESSEN
            MOVLW   D'1'        ;
            MOVWF   IMPULS      ;

RX1         NOP
            NOP 
            NOP 
            NOP 
            INCFSZ  IMPULS, F   ;T=4
            GOTO    RX3         ;T=8 GESAMT: T=12

            MOVLW   0XFF        ;BERLAUF BEI GRSSER 2,1MSEC
            MOVWF   IMPULS
RX2         BTFSS   GPIO, GP5
            GOTO    RX2
            GOTO    RXSTELL1

RX3         BTFSS   GPIO, GP5   ;T=4        ;STEIGENDE FLANKE == ZEITMESSUNG BEENDEN
            GOTO    RX1         ;T=8 +GESAMT AUCH VON OBEN: 12+12=24T

                                ;BERECHNUNG:
                                ;1,1MSEC : 250 ALS MAX.-WERT FR MERK = 4,4SEC
                                ;4,4SEC : 0,125SEC = 35,2T
                                
                                ;ALSO 35T - 24T = 11T
                                ;11 : X-MAL NOP (MIT T=4) = 2,75MAL NOP
                                ;ALSO 2 ODER 3 MAL NOPS EINTRAGEN BEI RX1  --->PROBIEREN

                                ;ERGEBNIS:
                                ;BEI 4 MAL NOPS GING ES AM BESTEN !!!!!!!!!!!!!!

;--------------------------------------------------------------------------------------
RXSTELL1        BTFSC   GPIO, GP3       ;KANAL1
                GOTO    K1OFF

K1ON            MOVF    MIN, W          ;FR KLEINER
                SUBWF   IMPULS, W       
                BTFSS   STATUS, C       ;CARRY-ABFRAGE
                GOTO    K1ON1
                BCF     GPIO, GP0       
                GOTO    K1OFF
K1ON1           BSF     GPIO, GP0       
                GOTO    RXSTELL2

K1OFF           MOVF    MIN, W          ;FR GRSSER
                SUBWF   IMPULS, W       
                BTFSC   STATUS, C       ;CARRY-ABFRAGE
                GOTO    K1OFF1

                BTFSS   STELL, BIT0
                GOTO    K1OFF2 
                BSF     GPIO, GP0
                BCF     MAL, BIT0
                GOTO    RXSTELL2

K1OFF2          BCF     GPIO, GP0
                BCF     MAL, BIT0
                GOTO    RXSTELL2


K1OFF1          BTFSC   MAL, BIT0
                GOTO    RXSTELL2
                BTFSC   STELL, BIT0
                GOTO    K1OFF3 
                BSF     STELL, BIT0
                BSF     MAL, BIT0
                GOTO    RXSTELL2

K1OFF3          BCF     STELL, BIT0
                BSF     MAL, BIT0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RXSTELL2        BTFSC   GPIO, GP2       ;KANAL2
                GOTO    K2OFF

K2ON            MOVF    MAX, W          ;FR KLEINER
                SUBWF   IMPULS, W       
                BTFSC   STATUS, C       ;CARRY-ABFRAGE
                GOTO    K2ON1
                BCF     GPIO, GP1       
                GOTO    K2OFF
K2ON1           BSF     GPIO, GP1       
                GOTO    RXEND

K2OFF           MOVF    MAX, W          ;FR GRSSER
                SUBWF   IMPULS, W       
                BTFSS   STATUS, C       ;CARRY-ABFRAGE
                GOTO    K2OFF1

                BTFSS   STELL, BIT1
                GOTO    K2OFF2 
                BSF     GPIO, GP1
                BCF     MAL, BIT1
                GOTO    RXEND

K2OFF2          BCF     GPIO, GP1
                BCF     MAL, BIT1
                GOTO    RXEND


K2OFF1          BTFSC   MAL, BIT1
                GOTO    RXEND
                BTFSC   STELL, BIT1
                GOTO    K2OFF3 
                BSF     STELL, BIT1
                BSF     MAL, BIT1
                GOTO    RXEND

K2OFF3          BCF     STELL, BIT1
                BSF     MAL, BIT1

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;,

RXEND           BCF     INTCON, GPIF        ;INTERRUPT-FLAG WIRD ERST BEI INTERRUPT GESETZT / JETZT LSCHEN
                BCF     INTCON, INTF        ;INTERRUPT-FLAG WIRD ERST BEI INTERRUPT GESETZT / JETZT LSCHEN

                POP
                RETFIE



;*****************************************************************************
;*                              X * 4SEC ZEITSCHLEIFE                       *
;*                              31.10.03                                     *
;*****************************************************************************
;ZSMUE       MOVWF   MERK

;A1          NOP 
;            NOP
;            NOP
 
;            NOP
            ;NOP   ;JUSTIERT
            ;NOP

;            DECFSZ  MERK, F
;            GOTO    A1

;            RETURN          ;DECFSZ 4T / JE NOP 4T  /// 1T=0,25SEC

                            ;1,1MSEC : 250 ALS MAX.-WERT FR MERK = 4,4SEC
                            ;4,4SEC : 0,125SEC = 35,2T
                            ;4T-FR DECFSZ - 8T-FR GOTO = 12T 
                            ;35T - 12T = 23T
                            ;23T : 4T-FR EINEM NOP = 6 MAL NOPS
                            ;GENOMMEN 5 MAL NOPS

;*****************************************************************************
;*                              UNTERPROGRAMM 1,0MSEC ZEITSCHLEIFE TIMER0    *
;*                              03.01.14                                     *
;*****************************************************************************
ZS1MSEC                 MOVWF   MERK

ZS11                    MOVLW   D'6'
                        MOVWF   TMR0                    ;DER FESTE RAM-SPEICHER (TMR0) WIRD MIT 100 GELADEN
                        BCF     INTCON, T0IF            ;OVERFLOW = 0
                
ZS12                    BTFSS   INTCON, T0IF            ;WENN DIE ZEIT VON 1MSEC ABGELAUFEN IST, WIRD T0IF HIGH (1) UND 
                        GOTO    ZS12                    ;ES ERFOLGT EIN SPRUNG ZU "DECFSC MERK, F"..... VORHER ANDERES ABARBEITEN

                        DECFSZ  MERK, F                 ;ES WIRD DER WERT IN "MERK" ABWRTS GEZHLT, BIS ER (0) IST UND
                        GOTO    ZS11                    ;DANN ERFOLGT EIN SPRUNG ZU "RETURN"-ENDE DES UNTERPROGRAMMS

                        RETURN

;ZEITBERECHNUNG FUER 1MS
;PRESCALER 8X  *  SYSTEM 4X  * TAKTZEIT ====> 8*4*0.125SEC=4,0SEC 
;1,0MS : 4,0SEC=250                                      
;ALSO NACHRECHNUNG 
;4SEC*D'250'=1,0MSEC
;TMR0 ALSO D'256'-D'250'=D'6' ENTSPRICHT 1,0MSEC
;6 DEZIMAL OBEN EINTRAGEN

;ZEITBERECHNUNG FUER 0,9MS
;PRESCALER 8X  *  SYSTEM 4X  * TAKTZEIT ====> 8*4*0.125SEC=4,0SEC 
;0,9MS : 4,0SEC=225                                      
;ALSO NACHRECHNUNG 
;4SEC*D'225'=0,9MSEC
;TMR0 ALSO D'256'-D'225'=D'31 ENTSPRICHT 0,9MSEC
;31 DEZIMAL OBEN EINTRAGEN


            END
