
;****************************************************************************************
;*                              SERVO-SCHALTER                                          *
;*                              15.05.16                                                *
;*--------------------------------------------------------------------------------------*
;*                                                                                      *
;* ALS PIC-IC WURDE GENOMMEN PIC12F683                                                  *
;* ALS OSZILLATOR WURDE DER INTERNE RC-OSZILLATOR MIT 8,000MHZ EINGESTELLT              *
;* (T=0.125SEC ALSO DIE TAKTZEIT)                                                      *
;*  EIN BEFEHL HAT MEIST 4 TAKTE SIND 0,5SEC                                           *
;*                                                                                      *
;****************************************************************************************

        LIST    P=12F683       
        TITLE   "SERVO-SCHALTER"

        ERRORLEVEL -302
        INCLUDE <P12F683.INC>


__CONFIG _INTRC_OSC_NOCLKOUT &_INTOSCIO & _IESO_OFF & _FCMEN_OFF &_WDT_OFF & _PWRTE_OFF & _BOD_OFF & _MCLRE_OFF & _CPD_OFF & _CP_OFF


;--------------------------------------------------------------------------
;REGISTER ZUORDNEN NACH DEM DIE FESTEN-REGISTER ZU ENDE SIND
;ES GEHT ALSO ERST AB 22 HEX LOS
;DIES IST ALSO DIE RAM-SPEICHER ZUORDNUNG


MERK                    EQU 0X22
;ZEITVARIABLE IN UNTERPROG. / VERARBEITET DIE DURCHLUFE / WIE OFT DIE ZEITSCHLEIFE ABGEARBEITET WIRD
;WERTE VON 1 DEZ. BIS 255 DEZ.

IMPULS                  EQU 0X23               ;MESSEN RX-IMPULSLNGE

STELL                   EQU 0X24               ;STELLEN/SCHALTEN 

MAL                     EQU 0X25               ;NUR 1 MAL BEI FLIP-FLOP

IMPULS_L                EQU 0X26               ;BERECHNUNG AUTOMATISCHE MITTELSTELLUNG
IMPULS_H                EQU 0X27
ZAE                     EQU 0X28

MIN                     EQU 0X29               ;UNTERHALB VOM STEUERHEBEL SCHALTET ES
MAX                     EQU 0X2A               ;OBERHALB VOM STEUERHEBEL SCHALTET ES

W_STACK                 EQU 0X2B               ;FUER PUSH UND POP ;FUER INTERRUPT
S_STACK                 EQU 0X2C               ;FUER PUSH UND POP

KANAL_ZUSTAND           EQU 0X2D               ;KANALZUSTAND, OB EIN ODER AUS
                                               ;KANAL01 TASTER BIT0 HIGH EIN LOW AUS
                                               ;KANAL02 TASTER BIT1 HIGH EIN LOW AUS
                                               ;KANAL01 MEMORY BIT3 HIGH EIN LOW AUS
                                               ;KANAL02 MEMORY BIT4 HIGH EIN LOW AUS
                                                              
MESS_ZAE                EQU 0X2E               ;MESSZHLER
GEMESSEN                EQU 0X2F               ;OB GEMESSEN WURDE IM INTERRUPT                
KANAL_MERK              EQU 0X30               ;KANALZUSTANDS-MERKER                 
                 
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;--------------------------------------------------------------------------
;-------------------------- FESTE WERTE HIER EINTRAGEN / NDERN -----------
;-------------------------- ALSO HIER JUSTIEREN ---------------------------
;-------------------------- MAN MUSS PROBIEREN ----------------------------

;--------------------------------------------------------------------------                 
;HIER KOENNTE MAN AENDERN
                 
;MAN KANN ZAHLEN VON D'1' BIS D'255' EINTRAGEN
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;FR KANAL
MIN_                    EQU D'76'               ;UNTERHALB 20% VON STEUERHEBEL SCHALTET ES

;FR ANDEREN KANAL
MAX_                    EQU D'178'              ;OBERHALB 80% VON STEUERHEBEL SCHALTET ES

;BERECHNUNG:
;DEZIMAL 255 ENTSPRECHEN 100%
;FR MITTELSTELLUNG DES STEUERKNPPELS SIND ES 50%

;BEISPIEL +-10% VON MITTELSTELLUNG AUS:
;FR 40%
;255*0,4=102 DIES OBEN EINTRAGEN
;FR 60%
;255*0,6=153 DIES OBEN EINTRAGEN

;BEISPIEL +-20% VON MITTELSTELLUNG AUS:
;FR 30%
;255*0,3=76 DIES OBEN EINTRAGEN
;FR 70%
;255*0,7=178 DIES OBEN EINTRAGEN

;BEISPIEL +-30% VON MITTELSTELLUNG AUS:
;FR 20%
;255*0,2=51 DIES OBEN EINTRAGEN
;FR 80%
;255*0,8=204 DIES OBEN EINTRAGEN


;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!                         
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MESSUNGEN               EQU D'5'
               
;OBEN SIND 5 IMPULS-LNGEN-MESSUNGEN EINGETRAGEN
;ES SCHALTET ERST WENN 5 MESSUNGEN NACH EINANDER DIE SELBE AUSWERTUNGEN BRINGEN
;FEHLIMPULSE WERDEN SO BEIM EIN- UND AUSSCHALTEN DES SENDERS UNTERDRCKT
;ABER ES WIRD TRGER/LANGSAMER BEIM SCHALTEN --> 5*20MSEC = 100MSEC TRAEGHEIT BIS ES ERST SCHALTET               
             
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;------------------------------- ENDE -------------------------------------

;------------------------- MACROS -----------------------------------------

BANK0                   MACRO                   ;MACRO TO SELECT DATA RAM BANK 0
                        BCF     STATUS,RP0
                        ENDM
;----------------------------------------------------------------------------
BANK1                   MACRO                   ;MACRO TO SELECT DATA RAM BANK 1
                        BSF     STATUS,RP0
                        ENDM
;----------------------------------------------------------------------------
PUSH                    MACRO
                        MOVWF   W_STACK
                        MOVF    STATUS, W
                        MOVWF   S_STACK
                        ENDM
;----------------------------------------------------------------------------
POP                     MACRO
                        MOVF    S_STACK, W
                        MOVWF   STATUS
                        SWAPF   W_STACK, F
                        SWAPF   W_STACK, W
                        ENDM
;----------------------------------------------------------------------------


;VARIABLEN
BIT0        EQU 0
BIT1        EQU 1
BIT2        EQU 2
BIT3        EQU 3
BIT4        EQU 4
BIT5        EQU 5
BIT6        EQU 6
BIT7        EQU 7

GP0         EQU 0
GP1         EQU 1 
GP2         EQU 2 
GP3         EQU 3 
GP4         EQU 4
GP5         EQU 5 



;SPEICHERANFANG BZW. BEGINN
    ORG 0X0000
    GOTO MAIN           ; SPRUNG ZUM HAUPTPROGRAMM
    ORG 0X0004
    GOTO INTERRUPT      ; ZUM INTERRUPT

    ORG 0X0010
;*****************************************************************************
;*                            HAUPTPROGRAMM                                  *
;*****************************************************************************
;PORT-INITIALISIERUNG
MAIN                    BANK0
                        CLRF    GPIO     
                        MOVLW   0X07                        ;COMPARATORS ALLE AUS 
                        MOVWF   CMCON0

                        BANK1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 
                        CLRF    ANSEL                       ;ALLE PORTS I/O

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                        MOVLW   B'11101100'                 ;GP0 + GP1 + GP4 ALS AUSGANG (ALSO HIER DIE 0), SONST ALLES EINGNGE (ALSO IMMER DIE (1))
                        MOVWF   TRISIO

;OSCILLATOR AUF 8MHZ INTERN EINSTELLEN
                        MOVLW   B'01110101'
                        MOVWF   OSCCON

;INIT TIMER0
                        MOVLW   B'10000010'   ;BIT0-2 1=PRESCALER 1:8, BIT3 0=TMR0, BIT4 0=ENTFAELLT, 
                                              ;BIT5 0=TAKT VOM SYSTEM, BIT6 0=KEIN RB-INTERRUPT, BIT7 1=PULL-UPS DISABLE 
                        MOVWF   OPTION_REG

;INIT INTERRUPT AN GP5
                        BCF     OPTION_REG, INTEDG  ;FALLENDE FLANKE ZULASSEN
                        BSF     INTCON, GPIE        ;INTERRUPT FR EXTERNEN PIN ZULASSEN MIT CHANGE VON GP2 AUF GP-EINGANG!!!
                        BSF     IOC, IOC5           ;ANDERS ZUSTZLICH ZU GP2 
                        BANK0

;DIE LEDS... SOLLEN AM ANFANG AUS SEIN              
                        BCF     GPIO, GP0                   ;AUS
                        BCF     GPIO, GP1                   ;AUS
                        BCF     GPIO, GP4                   ;AUS

                        CLRF    STELL
                        CLRF    MAL

;INTERRUPT GP5 INIT / ZULASSEN
;FR EMPFNGER-SERVO-IMPULS VON 1,9MSEC-2,1MSEC MESSEN
                        BCF     INTCON, GPIF        ;INTERRUPT-FLAG WIRD ERST BEI INTERRUPT GESETZT / JETZT LSCHEN
                        BCF     INTCON, INTF        ;INTERRUPT-FLAG WIRD ERST BEI INTERRUPT GESETZT / JETZT LSCHEN
;----------------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------------
;------------------------- INITIALISIERUNG PORTS... ZU ENDE -----------------------------------------
;----------------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------------

            MOVLW   D'50'
            CALL    ZS1MSEC             ;50MSEC ZEITSCHLEIFE DAMIT SICH KONDENSATOREN AUFLADEN NACH DEM EINSCHALTEN
;----------
;WENN MAN DEN SENDER ZUERST EINSCHALTET WARTET ES AUF 100 IMPULSE

;WENN DER EMPFNGER ZUERST AN IST, WIRD ERST NACH 100 VOR-IMPULSEN GEMESSEN.
;ES MUSS SICH DER SENDER ERST EINSCHWINGEN
;            MOVLW   VOR_IMPULSE
;            MOVWF   ZAE                 ;100 MAL DURCHLUFE

;VOR1        BTFSC   GPIO, GP5           ;WARTEN BIS ES NEGATIV WIRD 
;            GOTO    VOR1

;VOR         BTFSS   GPIO, GP5           ;IMPULS-LNGE IST LOW
;            GOTO    VOR

;            DECFSZ  ZAE, F              ;DURCHLUFE ZAEHLEN
;            GOTO    VOR1

;----------
;----------
;----------


            CLRF    KANAL_ZUSTAND
            CLRF    KANAL_MERK
            CLRF    GEMESSEN
            MOVLW   MESSUNGEN
            MOVWF   MESS_ZAE
            
            BSF     STELL, BIT0         ;DAMIT ZUM ERSTEN MAL EIN
            BSF     MAL, BIT0

            MOVLW   MAX_
            MOVWF   MAX
            MOVLW   MIN_
            MOVWF   MIN
            
            
            
            BSF     GPIO, GP4           ;KONTROLL-LED EIN

            BSF     INTCON, GIE         ;INTERRUPT EINSCHALTEN

;----------------------------------------------------------------------------------------------------
ANF
            BTFSS   GEMESSEN, BIT0      ;BEI HIGH WURDE IM INTERRUPT GEMESSEN   
            GOTO    ANF

            BCF     GEMESSEN, BIT0  ;NICHT GEMESSEN / ERST IM INTERRUPT
                
            MOVF    KANAL_MERK, W
            SUBWF   KANAL_ZUSTAND, W
            BTFSS   STATUS, Z
            GOTO    RUECKSTELL
            
            DECFSZ  MESS_ZAE, F
            GOTO    ANF
            
            MOVLW   MESSUNGEN
            MOVWF   MESS_ZAE

            
;KANAL01            
                BTFSC   GPIO, GP3       ;KANAL1
                GOTO    WEITER04        ;GEHT ZU MODE ALS MEMORY
                
;KANAL01 TASTER
            BTFSS   KANAL_ZUSTAND, BIT0 ;KANAL01 TASTER
            GOTO    WEITER01
            BSF     GPIO, BIT0 ;KANAL01 EIN
            GOTO    WEITER05
            
WEITER01    BCF     GPIO, BIT0 ;KANAL01 AUS
            GOTO    WEITER05

;KANAL01 MEMORY                  
WEITER04
                BTFSS   KANAL_ZUSTAND, BIT3
                GOTO    WEITER07
          
                BTFSS   STELL, BIT0     ;KLEINER
                GOTO    WEITER06 
                BSF     GPIO, BIT0
                BCF     MAL, BIT0
                GOTO    WEITER05        ;ZU KANAL 2

WEITER06        BCF     GPIO, BIT0
                BCF     MAL, BIT0
                GOTO    WEITER05        ;ZU KANAL 2


WEITER07        BTFSC   MAL, BIT0
                GOTO    WEITER05        ;ZU KANAL 2
                BTFSC   STELL, BIT0
                GOTO    WEITER08 
                BSF     STELL, BIT0
                BSF     MAL, BIT0
                GOTO    WEITER05        ;ZU KANAL 2

WEITER08        BCF     STELL, BIT0
                BSF     MAL, BIT0
                
        
                         
                
;KANAL02                
WEITER05
                BTFSC   GPIO, GP2     ;KANAL2
                GOTO    WWEITER02     ;GEHT ZU MODE ALS MEMORY
                
;KANAL02 TASTER                
            BTFSS   KANAL_ZUSTAND, BIT1 ;KANAL02 TASTER
            GOTO    WWEITER01
            BSF     GPIO, BIT1 ;KANAL02 EIN
            GOTO    WWEITER02
            
WWEITER01   BCF     GPIO, BIT1 ;KANAL02 AUS
            GOTO    ANF    
                
;KANAL02 MEMORY                  
WWEITER02
                BTFSS   KANAL_ZUSTAND, BIT4
                GOTO    WWEITER07
          
                BTFSS   STELL, BIT1     
                GOTO    WWEITER06 
                BSF     GPIO, BIT1
                BCF     MAL, BIT1
                GOTO    WWEITER05        

WWEITER06       BCF     GPIO, BIT1
                BCF     MAL, BIT1
                GOTO    WWEITER05        


WWEITER07       BTFSC   MAL, BIT1
                GOTO    WWEITER05        
                BTFSC   STELL, BIT1
                GOTO    WWEITER08 
                BSF     STELL, BIT1
                BSF     MAL, BIT1
                GOTO    WWEITER05        

WWEITER08       BCF     STELL, BIT1
                BSF     MAL, BIT1
                
WWEITER05       GOTO    ANF
          
            
          
            
            
            
            
RUECKSTELL  MOVLW   MESSUNGEN
            MOVWF   MESS_ZAE
            
            MOVF    KANAL_ZUSTAND, W
            MOVWF   KANAL_MERK
            GOTO    ANF
 
;*****************************************************************************
;*                              INTERRUPT-PROGRAMM                           *
;*                              19.09.05                                     *
;*****************************************************************************
INTERRUPT   PUSH

;EMPFNGER-IMPULS-LNGE MESSEN
;FESTE IMPULS-ZEIT 0,9MSEC ///BERECHNUNG DER 31DEZ. STEHT UNTERHALB BEI ZEITSCHLEIFEN UNTERPROGRAMM !
;AN GP5 MESSEN
            MOVLW   D'31'
            MOVWF   TMR0                    ;DER FESTE RAM-SPEICHER (TMR0) WIRD MIT 31 GELADEN
            BCF     INTCON, T0IF            ;OVERFLOW = 0
                
RX0         BTFSS   INTCON, T0IF            ;WENN DIE ZEIT VON 1MSEC ABGELAUFEN IST, WIRD T0IF HIGH (1) UND 
            GOTO    RX0                     ;ES ERFOLGT EIN SPRUNG 


;IMPULSZEIT MESSEN
            MOVLW   D'1'        ;
            MOVWF   IMPULS      ;

RX1         NOP
            NOP 
            NOP 
            NOP 
            INCFSZ  IMPULS, F   ;T=4
            GOTO    RX3         ;T=8 GESAMT: T=12

            MOVLW   0XFF        ;BERLAUF BEI GRSSER 2,1MSEC
            MOVWF   IMPULS
RX2         BTFSS   GPIO, GP5
            GOTO    RX2
            GOTO    RXSTELL1

RX3         BTFSS   GPIO, GP5   ;T=4        ;STEIGENDE FLANKE == ZEITMESSUNG BEENDEN
            GOTO    RX1         ;T=8 +GESAMT AUCH VON OBEN: 12+12=24T

                                ;BERECHNUNG:
                                ;1,1MSEC : 250 ALS MAX.-WERT FR MERK = 4,4SEC
                                ;4,4SEC : 0,125SEC = 35,2T
                                
                                ;ALSO 35T - 24T = 11T
                                ;11 : X-MAL NOP (MIT T=4) = 2,75MAL NOP
                                ;ALSO 2 ODER 3 MAL NOPS EINTRAGEN BEI RX1  --->PROBIEREN

                                ;ERGEBNIS:
                                ;BEI 4 MAL NOPS GING ES AM BESTEN !!!!!!!!!!!!!!

;--------------------------------------------------------------------------------------
;KANAL1                                
RXSTELL1        
                BTFSC   GPIO, GP3       ;KANAL1
                GOTO    K1OFF           ;GEHT ZU MODE ALS MEMORY

;ALS MODE TASTER                
K1ON            MOVF    MIN, W          ;FR KLEINER SCHALTEN EIN
                SUBWF   IMPULS, W       
                BTFSS   STATUS, C       ;CARRY-ABFRAGE
                GOTO    K1ON1
                BCF     KANAL_ZUSTAND, BIT0
                ;BCF     GPIO, GP0       ;FUER GROESSER/GLEICH
                GOTO    RXSTELL2        ;ZU KANAL 2          ;K1OFF       ;?????????
K1ON1           BSF     KANAL_ZUSTAND, BIT0
                ;BSF     GPIO, GP0       ;FUER KLEINER       
                GOTO    RXSTELL2        ;ZU KANAL 2

;ALS MODE MEMORY
K1OFF           MOVF    MIN, W          ;FR KLEINER SCHALTEN EIN
                SUBWF   IMPULS, W       
                BTFSS   STATUS, C       ;CARRY-ABFRAGE
                GOTO    K1ON11
                BCF     KANAL_ZUSTAND, BIT3
                ;BCF     GPIO, GP0       ;FUER GROESSER/GLEICH
                GOTO    RXSTELL2        ;ZU KANAL 2          ;K1OFF       ;?????????
K1ON11          BSF     KANAL_ZUSTAND, BIT3
                ;BSF     GPIO, GP0       ;FUER KLEINER       
                GOTO    RXSTELL2        ;ZU KANAL 2
                
    
                
                
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;KANAL2                
RXSTELL2        BTFSC   GPIO, GP2       ;KANAL2
                GOTO    K2OFF           ;GEHT ZU MODE ALS MEMORY
                
;ALS MODE TASTER
K2ON            MOVF    MAX, W          ;FR GROESSER SCHALTEN EIN
                SUBWF   IMPULS, W       
                BTFSC   STATUS, C       ;CARRY-ABFRAGE
                GOTO    K2ON1
                BCF     KANAL_ZUSTAND, BIT1
                ;BCF     GPIO, GP1       ;BEI KLEINER       
                GOTO    RXEND           ;ZUM ENDE ;K2OFF        ;??????
K2ON1           BSF     KANAL_ZUSTAND, BIT1
                ;BSF     GPIO, GP1       ;BEI GROESSER/GLEICH       
                GOTO    RXEND           ;ZUM ENDE

;ALS MODE MEMORY
K2OFF           MOVF    MAX, W          ;FR GROESSER SCHALTEN EIN
                SUBWF   IMPULS, W       
                BTFSC   STATUS, C       ;CARRY-ABFRAGE
                GOTO    K2ON11
                BCF     KANAL_ZUSTAND, BIT4
                ;BCF     GPIO, GP1       ;BEI KLEINER       
                GOTO    RXEND           ;ZUM ENDE ;K2OFF        ;??????
K2ON11          BSF     KANAL_ZUSTAND, BIT4
                ;BSF     GPIO, GP1       ;BEI GROESSER/GLEICH       
                GOTO    RXEND           ;ZUM ENDE
                
         
                
                
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;,

RXEND           BSF     GEMESSEN, BIT0      ;ES WURDE IMPULSZEIT GEMESSEN
                
                BCF     INTCON, GPIF        ;INTERRUPT-FLAG WIRD ERST BEI INTERRUPT GESETZT / JETZT LSCHEN
                BCF     INTCON, INTF        ;INTERRUPT-FLAG WIRD ERST BEI INTERRUPT GESETZT / JETZT LSCHEN

                POP
                RETFIE



;*****************************************************************************
;*                              X * 4SEC ZEITSCHLEIFE                       *
;*                              31.10.03                                     *
;*****************************************************************************
;ZSMUE       MOVWF   MERK

;A1          NOP 
;            NOP
;            NOP
 
;            NOP
            ;NOP   ;JUSTIERT
            ;NOP

;            DECFSZ  MERK, F
;            GOTO    A1

;            RETURN          ;DECFSZ 4T / JE NOP 4T  /// 1T=0,25SEC

                            ;1,1MSEC : 250 ALS MAX.-WERT FR MERK = 4,4SEC
                            ;4,4SEC : 0,125SEC = 35,2T
                            ;4T-FR DECFSZ - 8T-FR GOTO = 12T 
                            ;35T - 12T = 23T
                            ;23T : 4T-FR EINEM NOP = 6 MAL NOPS
                            ;GENOMMEN 5 MAL NOPS

;*****************************************************************************
;*                              UNTERPROGRAMM 1,0MSEC ZEITSCHLEIFE TIMER0    *
;*                              03.01.14                                     *
;*****************************************************************************
ZS1MSEC                 MOVWF   MERK

ZS11                    MOVLW   D'6'
                        MOVWF   TMR0                    ;DER FESTE RAM-SPEICHER (TMR0) WIRD MIT 100 GELADEN
                        BCF     INTCON, T0IF            ;OVERFLOW = 0
                
ZS12                    BTFSS   INTCON, T0IF            ;WENN DIE ZEIT VON 1MSEC ABGELAUFEN IST, WIRD T0IF HIGH (1) UND 
                        GOTO    ZS12                    ;ES ERFOLGT EIN SPRUNG ZU "DECFSC MERK, F"..... VORHER ANDERES ABARBEITEN

                        DECFSZ  MERK, F                 ;ES WIRD DER WERT IN "MERK" ABWRTS GEZHLT, BIS ER (0) IST UND
                        GOTO    ZS11                    ;DANN ERFOLGT EIN SPRUNG ZU "RETURN"-ENDE DES UNTERPROGRAMMS

                        RETURN

;ZEITBERECHNUNG FUER 1MS
;PRESCALER 8X  *  SYSTEM 4X  * TAKTZEIT ====> 8*4*0.125SEC=4,0SEC 
;1,0MS : 4,0SEC=250                                      
;ALSO NACHRECHNUNG 
;4SEC*D'250'=1,0MSEC
;TMR0 ALSO D'256'-D'250'=D'6' ENTSPRICHT 1,0MSEC
;6 DEZIMAL OBEN EINTRAGEN

;ZEITBERECHNUNG FUER 0,9MS
;PRESCALER 8X  *  SYSTEM 4X  * TAKTZEIT ====> 8*4*0.125SEC=4,0SEC 
;0,9MS : 4,0SEC=225                                      
;ALSO NACHRECHNUNG 
;4SEC*D'225'=0,9MSEC
;TMR0 ALSO D'256'-D'225'=D'31 ENTSPRICHT 0,9MSEC
;31 DEZIMAL OBEN EINTRAGEN


            END
